#version 120
#extension GL_EXT_geometry_shader4 : enable


void main( void )
{
	float multiplier = 40.0f;
	vec3 centerOfLine = 0.5 * ( gl_TexCoordIn[0][5].xyz + gl_TexCoordIn[1][5].xyz );
	vec3 lineToLight = normalize( gl_LightSource[0].position.xyz - centerOfLine );
	
	// It's only a silhouette if one facet faces front and one faces back (e.g., 1 dot prod positive, 1 negative)
	if ( dot(gl_TexCoordIn[0][0].xyz,lineToLight) * dot(gl_TexCoordIn[0][1].xyz,lineToLight) <= 0 ) 
	{
		vec3 dir0 = normalize( gl_TexCoordIn[0][5].xyz - gl_LightSource[0].position.xyz );
		vec3 dir1 = normalize( gl_TexCoordIn[1][5].xyz - gl_LightSource[0].position.xyz );
	
		// Check if this is a front or back facing shadow quad... 
		vec3 eysSpaceEdgeNorm = normalize( gl_TexCoordIn[0][5].xyz );
		vec3 normCrossDown = cross( eysSpaceEdgeNorm, dir0 );
		bool windingWrong = dot( normCrossDown, (gl_TexCoordIn[1][5].xyz-gl_TexCoordIn[0][5].xyz) ) < 0;
		float dotPd = windingWrong ? dot(gl_TexCoordIn[0][0].xyz,lineToLight) : dot(gl_TexCoordIn[0][1].xyz,lineToLight);
		gl_TexCoord[4] = vec4( dotPd < 0 ? 1 : 0 ); // 1 = back facing, 0 = frong facing
		gl_Layer = dotPd < 0 ? 1 : 0 ;
		
		gl_Position = gl_PositionIn[1];
		gl_TexCoord[5] = gl_TexCoordIn[1][5];
		EmitVertex();
		
		gl_Position = gl_ProjectionMatrix * vec4( (gl_TexCoordIn[1][5].xyz + multiplier*dir1), 1 );
		gl_TexCoord[5] = vec4( (gl_TexCoordIn[1][5].xyz + multiplier*dir1), 1 );
		EmitVertex();
		
		gl_Position = gl_PositionIn[0];
		gl_TexCoord[5] = gl_TexCoordIn[0][5];
		EmitVertex();
		
		gl_Position = gl_ProjectionMatrix * vec4( (gl_TexCoordIn[0][5].xyz + multiplier*dir0), 1 );
		gl_TexCoord[5] = vec4( (gl_TexCoordIn[0][5].xyz + multiplier*dir0), 1 );
		EmitVertex();
		EndPrimitive();
	}
}