#version 120
#extension EXT_gpu_shader4 : enable

uniform sampler2D sceneColorAndDist;

void main( void )
{	
	vec2 texCoord = gl_FragCoord.xy / 256;
	float fragDist = texture2D( sceneColorAndDist, texCoord ).w ;

	//gl_FragColor = vec4( min(fragDist, length( gl_TexCoord[5].xyz )) );
	gl_FragColor = vec4( clamp( length( gl_TexCoord[5].xyz ), 0.05, fragDist ) );
		
	//gl_FragColor = vec4(1,1,1,1);
		
	// Our back and front facing volumes are going to different buffers.  Since
	//    We want to find the frontmost front and the backmost back, but we must
	//    use the same depth test on both layers, we reverse the depth order for
	//    back-facing polygons.
	gl_FragDepth = gl_TexCoord[4].x > 0.5 ? 1-gl_FragCoord.z : gl_FragCoord.z ;
}