#version 120
#extension GL_EXT_geometry_shader4 : enable


void main( void )
{
	float multiplier = 40.0f;
	
	vec3 vert0ToLight = normalize( gl_LightSource[0].position.xyz - gl_PositionIn[0].xyz );
	vec3 v10          = normalize( gl_PositionIn[1].xyz - gl_PositionIn[0].xyz );
	vec3 v20          = normalize( gl_PositionIn[2].xyz - gl_PositionIn[0].xyz );
	vec3 facetNorm    = normalize( cross( v10, v20 ) );
	
	float lightFacing = dot( facetNorm, vert0ToLight ) >= 0 ? 0.0f : multiplier;
	bool frontFacing  = dot( facetNorm, normalize( gl_PositionIn[0].xyz ) ) <= 0;
	
	vec4 offsetV0 = gl_PositionIn[0] + vec4( lightFacing * normalize( gl_PositionIn[0].xyz - gl_LightSource[0].position.xyz ), 0 );
	vec4 offsetV1 = gl_PositionIn[1] + vec4( lightFacing * normalize( gl_PositionIn[1].xyz - gl_LightSource[0].position.xyz ), 0 );
	vec4 offsetV2 = gl_PositionIn[2] + vec4( lightFacing * normalize( gl_PositionIn[2].xyz - gl_LightSource[0].position.xyz ), 0 );
	
	// Output the triangle
	/*
	gl_Layer = frontFacing ? 0 : 1;
	gl_TexCoord[4] = vec4( frontFacing ? 0.0 : 1.0 ); 
	
	gl_Position = gl_ProjectionMatrix * offsetV0;
	gl_TexCoord[5] = offsetV0;
	EmitVertex();
	gl_Position = gl_ProjectionMatrix * offsetV1;
	gl_TexCoord[5] = offsetV1;
	EmitVertex();
	gl_Position = gl_ProjectionMatrix * offsetV2;
	gl_TexCoord[5] = offsetV2;
	EmitVertex();
	EndPrimitive();
	*/
	
	
	gl_Layer = 0;
	gl_TexCoord[4] = vec4(0.0); 
	
	gl_Position = gl_ProjectionMatrix * gl_PositionIn[0];
	gl_TexCoord[5] = gl_PositionIn[0];
	EmitVertex();
	gl_Position = gl_ProjectionMatrix * gl_PositionIn[1];
	gl_TexCoord[5] = gl_PositionIn[1];
	EmitVertex();
	gl_Position = gl_ProjectionMatrix * gl_PositionIn[2];
	gl_TexCoord[5] = gl_PositionIn[2];
	EmitVertex();
	EndPrimitive();
	
	gl_Layer = 1;
	gl_TexCoord[4] = vec4(1.0); 
	
	gl_Position = gl_ProjectionMatrix * offsetV0;
	gl_TexCoord[5] = offsetV0;
	EmitVertex();
	gl_Position = gl_ProjectionMatrix * offsetV1;
	gl_TexCoord[5] = offsetV1;
	EmitVertex();
	gl_Position = gl_ProjectionMatrix * offsetV2;
	gl_TexCoord[5] = offsetV2;
	EmitVertex();
	EndPrimitive();
	
}